## org.bouncycastle.crypto
Interface Mac

All Known Implementing Classes:
  I2PHMac

    public interface Mac

The base interface for implementations of message authentication codes (MACs). modified by jrandom to use the session key byte array directly

Method Summary
`int` `doFinal(byte[] out, int outOff)` Compute the final statge of the MAC writing the output to the out parameter.
`String` `getAlgorithmName()` Return the name of the algorithm the MAC implements.
`int` `getMacSize()` Return the block size for this cipher (in bytes).
`void` `init(byte[] key)` Initialise the MAC.
`void` `reset()` Reset the MAC.
`void` `update(byte in)` add a single byte to the mac for processing.
`void` `update(byte[] in, int inOff, int len)`

Method Detail

### init

    void init(byte[] key)
              throws IllegalArgumentException

  Initialise the MAC.

  Parameters:
    `key` - the key required by the MAC.
  Throws:
    `IllegalArgumentException` - if the params argument is inappropriate.

### getAlgorithmName

    String getAlgorithmName()

  Return the name of the algorithm the MAC implements.

  Returns:
    the name of the algorithm the MAC implements.

### getMacSize

    int getMacSize()

  Return the block size for this cipher (in bytes).

  Returns:
    the block size for this cipher in bytes.

### update

    void update(byte in)
                throws IllegalStateException

  add a single byte to the mac for processing.

  Parameters:
    `in` - the byte to be processed.
  Throws:
    `IllegalStateException` - if the MAC is not initialised.

### update

    void update(byte[] in,
                int inOff,
                int len)
                throws IllegalStateException

  Parameters:
    `in` - the array containing the input.
    `inOff` - the index in the array the data begins at.
    `len` - the length of the input starting at inOff.
  Throws:
    `IllegalStateException` - if the MAC is not initialised.

### doFinal

    int doFinal(byte[] out,
                int outOff)
                throws IllegalStateException

  Compute the final statge of the MAC writing the output to the out parameter.

  doFinal leaves the MAC in the same state it was after the last init.

  Parameters:
    `out` - the array the MAC is to be output to.
    `outOff` - the offset into the out buffer the output is to start at.
  Throws:
    `IllegalStateException` - if the MAC is not initialised.

### reset

    void reset()

  Reset the MAC. At the end of resetting the MAC should be in the in the same state it was after the last init (if there was one).